Package com.io7m.cedarbridge.codegen.java.internal

# Class CBCGJavaTypeNames

java.lang.Object
com.io7m.cedarbridge.codegen.java.internal.CBCGJavaTypeNames

public final class CBCGJavaTypeNames extends Object
Functions over Java type names.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static com.io7m.jodist.ClassName`
  `dataClassNameOf(CBTypeDeclarationType type)`
  Generate the Java data class name for the given type.
  `static com.io7m.jodist.ClassName`
  `dataClassNameOfCase(CBVariantCaseType caseV)`
  Generate the Java data class name for the given case.
  `static com.io7m.jodist.TypeName`
  `dataTypeNameOf(CBTypeDeclarationType type)`
  Generate the Java type name (including generic parameters) for the given type.
  `static com.io7m.jodist.TypeName`
  `dataTypeNameOfCase(CBVariantCaseType caseV)`
  Generate the Java type name (including generic parameters) for the given case.
  `static CBExternalName`
  `externalNameOf(CBTypeDeclarationType type)`
  Generate the external name for the given type.
  `static com.io7m.jodist.TypeName`
  `externalTypeNameOf(CBExternalType decl)`
  Generate the external type name for the given type.
  `static String`
  `fieldAccessorName(String name)`
  Generate the field accessor name for the given field name.
  `static com.io7m.jodist.ClassName`
  `protoInterfaceNameOf(CBProtocolDeclarationType proto)`
  Generate the Java interface name for the given protocol.
  `static com.io7m.jodist.ClassName`
  `protoNameOf(CBProtocolDeclarationType proto)`
  Generate the Java class name for the given protocol.
  `static com.io7m.jodist.ClassName`
  `protoSerializerClassNameOf(CBProtocolVersionDeclarationType proto)`
  Generate the Java serializer class name for the given protocol version.
  `static com.io7m.jodist.ClassName`
  `protoSerializerFactoryClassNameOf(CBProtocolVersionDeclarationType proto)`
  Generate the Java serializer factory class name for the given protocol version.
  `static com.io7m.jodist.ClassName`
  `protoVersionedInterfaceNameOf(CBProtocolVersionDeclarationType proto)`
  Generate the Java interface name for the given protocol version.
  `static com.io7m.jodist.ClassName`
  `serializerClassNameOf(CBTypeDeclarationType type)`
  Generate the Java serializer class name for the given type.
  `static com.io7m.jodist.ClassName`
  `serializerCollectionClassNameOf(String packageName)`
  Generate the serializer collection class name for the given package name.
  `static com.io7m.jodist.ClassName`
  `serializerFactoryClassNameOf(CBTypeDeclarationType type)`
  Generate the Java serializer factory class name for the given type.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### protoNameOf

    public static com.io7m.jodist.ClassName protoNameOf(CBProtocolDeclarationType proto)
    Generate the Java class name for the given protocol.
    Parameters:
      `proto` - The protocol
    Returns:
      The Java class name

  - ### protoInterfaceNameOf

    public static com.io7m.jodist.ClassName protoInterfaceNameOf(CBProtocolDeclarationType proto)
    Generate the Java interface name for the given protocol.
    Parameters:
      `proto` - The protocol
    Returns:
      The Java interface name

  - ### protoVersionedInterfaceNameOf

    public static com.io7m.jodist.ClassName protoVersionedInterfaceNameOf(CBProtocolVersionDeclarationType proto)
    Generate the Java interface name for the given protocol version.
    Parameters:
      `proto` - The protocol version
    Returns:
      The Java interface name

  - ### dataClassNameOf

    public static com.io7m.jodist.ClassName dataClassNameOf(CBTypeDeclarationType type)
    Generate the Java data class name for the given type.
    Parameters:
      `type` - The type
    Returns:
      The Java data class name

  - ### dataTypeNameOf

    public static com.io7m.jodist.TypeName dataTypeNameOf(CBTypeDeclarationType type)
    Generate the Java type name (including generic parameters) for the given type.
    Parameters:
      `type` - The type
    Returns:
      The Java type name

  - ### dataTypeNameOfCase

    public static com.io7m.jodist.TypeName dataTypeNameOfCase(CBVariantCaseType caseV)
    Generate the Java type name (including generic parameters) for the given case.
    Parameters:
      `caseV` - The case
    Returns:
      The Java type name

  - ### dataClassNameOfCase

    public static com.io7m.jodist.ClassName dataClassNameOfCase(CBVariantCaseType caseV)
    Generate the Java data class name for the given case.
    Parameters:
      `caseV` - The case
    Returns:
      The Java data class name

  - ### protoSerializerClassNameOf

    public static com.io7m.jodist.ClassName protoSerializerClassNameOf(CBProtocolVersionDeclarationType proto)
    Generate the Java serializer class name for the given protocol version.
    Parameters:
      `proto` - The protocol version
    Returns:
      The Java serializer class name

  - ### protoSerializerFactoryClassNameOf

    public static com.io7m.jodist.ClassName protoSerializerFactoryClassNameOf(CBProtocolVersionDeclarationType proto)
    Generate the Java serializer factory class name for the given protocol version.
    Parameters:
      `proto` - The protocol version
    Returns:
      The Java serializer factory class name

  - ### serializerClassNameOf

    public static com.io7m.jodist.ClassName serializerClassNameOf(CBTypeDeclarationType type)
    Generate the Java serializer class name for the given type.
    Parameters:
      `type` - The type
    Returns:
      The Java serializer class name

  - ### serializerFactoryClassNameOf

    public static com.io7m.jodist.ClassName serializerFactoryClassNameOf(CBTypeDeclarationType type)
    Generate the Java serializer factory class name for the given type.
    Parameters:
      `type` - The type
    Returns:
      The Java serializer factory class name

  - ### externalNameOf

    public static CBExternalName externalNameOf(CBTypeDeclarationType type)
    Generate the external name for the given type.
    Parameters:
      `type` - The type
    Returns:
      The external name

  - ### externalTypeNameOf

    public static com.io7m.jodist.TypeName externalTypeNameOf(CBExternalType decl)
    Generate the external type name for the given type.
    Parameters:
      `decl` - The type
    Returns:
      The external type name

  - ### fieldAccessorName

    public static String fieldAccessorName(String name)
    Generate the field accessor name for the given field name.
    Parameters:
      `name` - The field name
    Returns:
      The field accessor name

  - ### serializerCollectionClassNameOf

    public static com.io7m.jodist.ClassName serializerCollectionClassNameOf(String packageName)
    Generate the serializer collection class name for the given package name.
    Parameters:
      `packageName` - The package name
    Returns:
      The serializer collection class name